extends Sprite

var shoot_time=0.35
var shoot_timer=0.0

onready var global_v=get_tree().get_root().get_node("scene")

var elema
func preload_shoot():
	elema=preload("res://b1.tscn")

var num_buf=2
func _ready():
	preload_shoot()
	var cnode=global_v.get_node("paint_FBO/Sprite")
	var iChannel=global_v.get_node("paint_buf").get_viewport().get_texture()
	iChannel.flags=Texture.FLAG_FILTER
	cnode.material.set("shader_param/iChannel0",iChannel)

var obc=false
func _process(delta):
	global_v.once=false
	self.material.set("shader_param/iTime",global_v.iTime)
	self.material.set("shader_param/iFrame",global_v.iFrame)
	
	shoot_timer+=delta
	if(Input.is_mouse_button_pressed(BUTTON_LEFT)):
		if(shoot_timer>shoot_time):
			shoot_timer=0
			obc=true
	
	if(obc):
		obc=false
		gen_shoot()
	

func angle2d(c, e):
	var theta = atan2(e.y-c.y, e.x-c.x)
	return theta

func gen_shoot():
	var s=elema.instance()
	s.get_node("b1").start_pos=Vector2(1280,720)/2.0
	s.get_node("b1").angle=angle2d(Vector2(1280,720)/2.0,Vector2(global_v.iMouse.x,OS.get_window_size().y-global_v.iMouse.y))
	global_v.call_deferred("add_child",s)